//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using Microsoft.CSharp;
using System.CodeDom.Compiler;

namespace CodeDomHelloWorld
{
	/// <summary>
	/// Summary description for CodeDomHelloWorldMain.
	/// </summary>
	class CSCodeDomCompiler
	{
		public static void CSharpCompilerTest(string source, string target)
		{
			// Now user the CodeProvider interface
			CSharpCodeProvider cscp = new CSharpCodeProvider();
			CompilerParameters param = new CompilerParameters(null, target, true);
			param.GenerateExecutable = true;
			ICodeCompiler cc = cscp.CreateCompiler();
			CompilerResults cr = cc.CompileAssemblyFromSource(param, source);
			System.Collections.Specialized.StringCollection output = cr.Output;
			foreach(string s in output)
			{
				Console.WriteLine(s);
			}

			if(cr.Errors.Count != 0)
			{
				CompilerErrorCollection es = cr.Errors;
				foreach(System.CodeDom.Compiler.CompilerError e in es)
				{
					Console.WriteLine(e.ToString());
				}
			}
			else
			{
				// Set ApplicationBase to the current directory
				AppDomainSetup info = new AppDomainSetup();
				info.ApplicationBase = "file:\\\\" + System.Environment.CurrentDirectory;
				// Create an application domain with null evidence
				AppDomain dom = AppDomain.CreateDomain("HelloWorld", null, info);
				dom.ExecuteAssembly(target);
				// Clean up by unloading the application domain
				AppDomain.Unload(dom);  
			}
		}
	}
}