//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;

namespace MatrixMultiplication
{
	/// <summary>
	/// Summary description for MatrixMultiplyDirect.
	/// </summary>
	public class MatrixMultiplyDirect : MatrixMultiply
	{
		public MatrixMultiplyDirect(double [,] A, double [,] B) : base(A,B)
		{
		}
		public override double [,] Multiply()
		{
			for(int i = 0; i < A.GetLength(0); i++)
				for(int j = 0; j < B.GetLength(1); j++)
					C[i,j] = 0.0;

			// Loop over the rows of A
			for(int i = 0; i < A.GetLength(0); i++)
				// Loop over the columns of A and rows of B
				for(int j = 0; j < A.GetLength(1); j++)
				{
					// Loop over the columns of B
					for(int k = 0; k < B.GetLength(1); k++)
						C[i,k] += A[i,j] * B[j,k];
				}
			return C;
		}
	}
}
