//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Reflection;

namespace LateBinding
{
	/// <summary>
	/// Summary description for LateBindingMain.
	/// </summary>
	class LateBindingMain
	{
		static void Main(string[] args)
		{
			Assembly first = Assembly.LoadFrom(@"..\..\First\bin\debug\first.dll");
			Assembly second = Assembly.LoadFrom(@"..\..\Second\bin\debug\second.dll");
			Assembly [] assemblies = new Assembly[] { first, second };
			foreach(Assembly a in assemblies)
			{
				Type[] types = a.GetTypes();
				foreach(Type t in types)
				{
					try
					{
						object o = Activator.CreateInstance(t);
						MethodInfo m = t.GetMethod("OutputMessage");
						m.Invoke(o, new object [] {"This is my message"});
					}
					catch(Exception e)
					{
						Console.WriteLine(e);
					}
				}
			}
		}
	}
}
